-- dithering matrix 3x3
function dithering(data)
	local width, height = data:getDimensions()
	local canvasImageData = love.image.newImageData(width, height)

--local matrix = {
--		{ 242, 43, 128 },
--		{ 14, 100,  185 },
--		{ 156, 213, 71 },
--}
--local matrix = {
--		{ 227, 56, 115 },
--		{ 28, 113,  171 },
--		{ 142, 199, 85 },
--}

local matrix = {
		{ 230, 51, 128 },
		{ 25, 102,  179 },
		{ 154, 205, 77 },
}

local sum = 0
for i = 1, 10 do
	local v = 256/10 + (i-1)*256/10
	print (v)
	sum = sum + v
end
print ('is it correct: 0.5	==', sum/256/10) -- must be 0.5
	
	for y = 0, height - 1 do
		for x = 0, width - 1 do
			local r, g, b, a = love.math.colorToBytes(data:getPixel(x, y))
			local i, j = x%3+1, y%3+1
			local matrixValue = matrix[j][i]
			r = r >= matrixValue and 1 or 0
			g = g >= matrixValue and 1 or 0
			b = b >= matrixValue and 1 or 0
			canvasImageData:setPixel(x, y, r, g, b, a)
		end
	end
	local canvas = love.graphics.newImage(canvasImageData)
	return canvas
end

return dithering