dithering = require ('dithering')

Scale = 3
TranslateX, TranslateY = 0, 0

function love.load()
	love.graphics.setDefaultFilter( "linear", "nearest")
	local imageData = love.image.newImageData('image.png')
--	local imageData = love.image.newImageData('cyanotype.png')
--	local imageData = love.image.newImageData('sepia.png')
	local width, height = imageData:getDimensions()
	height = height/3
	love.window.setMode (Scale*width*2, Scale*height)
	image1 = love.graphics.newImage(imageData)
	image2 = dithering(imageData)
	shiftX = imageData:getWidth( )
	shiftY = imageData:getHeight( )
end

function love.draw()
	love.graphics.push()
		love.graphics.translate(TranslateX, TranslateY)
		love.graphics.scale(Scale)
		love.graphics.setColor(1,1,1)
		love.graphics.draw(image1,0, 0)
		love.graphics.draw(image2,shiftX, 0)
	love.graphics.pop()
	love.graphics.setColor(0,1,0)
	love.graphics.print ((TranslateX .. '\n' ..  TranslateY .. '\n' .. Scale), 0, 0)
end

function zoomWindowToMouse (deltaScale)
  local mx, my = love.mouse.getPosition()
  local tx, ty = TranslateX, TranslateY
  local scale = Scale
	local newScale = math.max (1, scale + deltaScale)
  Scale = newScale
  TranslateX = math.floor((mx-((mx-tx)/scale)*newScale)+0.5)
  TranslateY = math.floor((my-((my-ty)/scale)*newScale)+0.5)
end

function love.wheelmoved(wx, wy)
	if not (wy == 0) then
		zoomWindowToMouse (wy)
	end
end